#! /usr/bin/env tclsh
# -*- tcl -*-

# <20160623.1920.00>
# 
# This code reads from std in and writes to std out.
# On the way thru any file names are run through glob
# to expand any wild cards. comments are tossed.

proc godown {f } {
  foreach file [glob -nocomplain $f/*] {
    if {[catch "file link $file"] == 0 } {continue}
    puts "$file"
    if {[file isdirectory $file]} {
      godown $file
    }
  }
}

while { 1 } {
  set count [gets stdin line]
  # puts "$count $line"
  if {$count == -1} {exit 0}
  if {$count == 0 || [string index $line 0] == "#"} {continue}

  foreach file [glob -nocomplain $line] {
    # we only want link files if they are explictly called out.
    if {[catch "file link $file"] == 0 && \
	    [string index $line end] == "*"} {continue}
    puts "$file"
    if {[string index $line end] == "*" && [file isdirectory $file]} {
      godown $file
    }
  }
}  
