#
# <20161231.1646.11>
#
# Seems tcl does not have a remove function that accepts list indics
# So, here we go...
#
# call:
#
# ldelete list indics
#
# removes the element addressed as in [lindex $list indics].  
#
# if element does not exist, just return what we got
#
proc ldelete {var indics} {
  if {$indics == {} || [lindex  $var $indics] == {}} {
      return $var
  }
  if {[llength $indics] == 1} {
    return [lreplace $var $indics $indics]
  } else {
    
    set entry [lassign $indics next]
    return [concat [lrange $var 0 $next-1]\
		[list [ldelete [lindex $var $next] $entry]]\
		[lrange $var $next+1 end]]
  }
}
